config/routes.rb
Rails.application.routes.draw do

  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)
  devise_for :users

  root 'static_pages#home'

  resources :line_items do
    match :qty, action: :qty, via: [:post, :delete], on: :member #-> url.com/line_items/qty
    match :input_field_change, action: :input_field_change, via: :post, on: :member
  end
  resources :carts do
    match :empty_line_items, action: :empty_line_items, via: :delete, on: :member #-> url.com/line_items/qty
  end

  get 'navbar_cart'           => 'carts#navbar_cart'
  get 'continue_shopping'     => 'carts#continue_shopping'
  get 'search'                => 'products#product_search'
  get 'checkout'              => 'charges#checkout'
  get 'support'               => 'support_messages#new'

  resources :carts, :orders
  resources :charges
  resources :categories, only: [:show, :index]
  resources :departments, only: [:index]
  resources :products, only: [:show, :index, :new, :create]
  resources :static_pages, only: [:home, :help]
  resources :support_messages, only: [:create]

   

end

app/models/line_item.rb
class LineItem < ActiveRecord::Base

	belongs_to :order
	belongs_to :product
	belongs_to :cart, :counter_cache => true

 	def total_price
 		if !product.discount.blank?
  		(product.price - product.discount) * quantity
  	else
  		product.price * quantity
  	end
  end

  def check_qty
    self.destroy if self.qty.zero?
  end

end

app/controllers/line_items_controller.rb
class LineItemsController < ApplicationController
  skip_before_action :authorize, only: :create
  include CurrentCart
  before_action :set_cart, only: [:create, :destroy, :qty, :decrease, :increase, :input_field_change]
  before_action :set_line_item, only: [:show, :edit, :update, :destroy]

  # GET /line_items
  # GET /line_items.json
  def index
    @line_items = LineItem.all
  end

  # GET /line_items/1
  # GET /line_items/1.json
  def show
  end

  # GET /line_items/new
  def new
    @line_item = LineItem.new
  end

  # GET /line_items/1/edit
  def edit
  end

  # POST /line_items
  # POST /line_items.json
  def create
    #set_cart
    product = Product.find(params[:product_id])
    @line_item = @cart.add_product(product.id)
    #expire_fragment('navbar')

    respond_to do |format|
      if @line_item.save
        format.html { redirect_to root_url }
        format.js { @current_item = @line_item }
        format.json { render action: 'show', 
          status: :created, location: @line_item }
      else
        format.html { render action: 'new' }
        format.json { render json: @line_item.errors, 
          status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /line_items/1
  # PATCH/PUT /line_items/1.json
  def update
    respond_to do |format|
      if @line_item.update(line_item_params)
        format.html { redirect_to @line_item, notice: 'Line item was successfully updated.' }
        format.json { render :show, status: :ok, location: @line_item }
      else
        format.html { render :edit }
        format.json { render json: @line_item.errors, status: :unprocessable_entity }
      end
    end
  end

 # DELETE /line_items/1
  # DELETE /line_items/1.json
  def destroy
    @line_item.destroy
    respond_to do |format|
      if @line_item.save
        format.js { @item = params[:id] }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @line_item.errors, status: :unprocessable_entity}
      end
    end
  end

  def qty
    @index = params[:index]
    if request.post? #-> increment
      increase
    elsif request.delete? #-> decrement
      decrease
    end

    #@item.send(method, :qty, params[:qty])
  end

  def decrease
    @line_item = @cart.decrease(params[:id])
    respond_to do |format|
      if @line_item.save
        format.js { @item = @cart.line_items.find(params[:id]) }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @line_item.errors, status: :unprocessable_entity}
      end
    end
  end

  def increase
    @line_item = @cart.increase(params[:id])
    respond_to do |format|
      if @line_item.save
        format.js   { @item = @cart.line_items.find(params[:id]) }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @line_item.errors, status: :unprocessable_entity }
      end
    end
  end

  def input_field_change
    @index = params[:index]
    @line_item = @cart.input_field_change(params[:id], params[:quantity])
    respond_to do |format|
      if @line_item.save
        format.js   { @item = @cart.line_items.find(params[:id]) }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @line_item.errors, status: :unprocessable_entity }
      end
    end
  end
  
  private
    # Use callbacks to share common setup or constraints between actions.
    def set_line_item
      @line_item = LineItem.find(params[:id])
    end
    # Never trust parameters from the scary internet, only allow the white list through.
  
    def line_item_params
      params.require(:line_item).permit(:product_id)
    end 
end

app/helpers/line_items_helper.rb
module LineItemsHelper
end

app/views/line_items/_form.html.erb
<%= form_for(@line_item) do |f| %>
  <% if @line_item.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@line_item.errors.count, "error") %> prohibited this line_item from being saved:</h2>

      <ul>
      <% @line_item.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :product_id %><br>
    <%= f.number_field :product_id %>
  </div>
  <div class="field">
    <%= f.label :cart_id %><br>
    <%= f.number_field :cart_id %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/line_items/_line_item.html.erb
<% if line_item == @current_item %>
<tr id = "current_item">
<% else %>
<tr>
<% end %>
	<td><%= line_item.quantity %>&times;</td>
	<td><%= line_item.product.title %></td>
	<td class = "item_price"><%= number_to_currency(line_item.total_price) %></td>
</tr>

app/views/line_items/_qty_n_price_row.html.erb
<div class="col-xs-4 col-md-4 text-left">
	<h6><strong><span class="text-muted">€<%= item.product.price_with_discount(item.product.price, item.product.discount) %> </span> <span> x </span></strong></h6>
</div>
<div class="col-xs-4 col-md-4">
	<%= number_field_tag 'quantity', item.quantity, { min: 1, :onchange => "input_change(#{index}, #{item.id})", id: "quantity-input-id-#{index}" } %>
</div>
<div class="col-xs-4 col-md-4 text-center">
	<!-- id = litp- = line item total price -->
	<h6><strong> <span id="litp-id-<%= index %>">= €<%= item.total_price %></span></strong></h6>
</div>

app/views/line_items/create.js.erb
$("#cart-badge-id").text(<%=@cart.line_items_count%>);
$('#cart-button').effect( "bounce", {times:1}, 200 );

app/views/line_items/destroy.js.erb
$('#line-item-row-id-<%= @item %>').remove();
$('#line-item-hr-id-<%= @item %>').remove();
if ($('[id^="line-item-row-id-"').length) {
	sum = 0;
	$('[id^="litp-id-"]').each(function() {
	   sum += parseFloat($(this).text().slice(3));
		});
	sum_total = sum.toFixed(2);
	$('#line-items-total-sum').text("Total: €" + sum_total).effect( "highlight", {color: 'green'}, 2500 );
	} else {
		location.reload();
}

app/views/line_items/edit.html.erb
<h1>Editing Line Item</h1>

<%= render 'form' %>

<%= link_to 'Show', @line_item %> |
<%= link_to 'Back', line_items_path %>

app/views/line_items/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Line Items</h1>

<table>
  <thead>
    <tr>
      <th>Product</th>
      <th>Cart</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @line_items.each do |line_item| %>
      <tr>
        <td><%= line_item.product_id %></td>
        <td><%= line_item.cart_id %></td>
        <td><%= link_to 'Show', line_item %></td>
        <td><%= link_to 'Edit', edit_line_item_path(line_item) %></td>
        <td><%= link_to 'Destroy', line_item, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Line item', new_line_item_path %>

app/views/line_items/input_field_change.js.erb
$(document).ready(function(){
	var sum = 0;
	$('#qty-n-price-row-<%= @index %>').html("<%= escape_javascript render(:partial => 'qty_n_price_row', :locals => { index: @index, item: @item } ) %>");
	$('#litp-id-<% @index %>').text("€")
	$('[id^="litp-id-"]').each(function() {
	   sum += parseFloat($(this).text().slice(3));
	});
	sum_total = sum.toFixed(2);
	$('#line-items-total-sum').text("€" + sum_total).effect( "highlight", {color: 'lightblue'}, 250 );
	$('#litp-id-<%= @index %>').effect( "highlight", {color: 'lightblue'}, 250 );
});

app/views/line_items/new.html.erb
<h1>New Line Item</h1>

<%= render 'form' %>

<%= link_to 'Back', line_items_path %>

app/views/line_items/qty.js.erb
$(document).ready(function(){
	var sum = 0;
	$('#qty-n-price-row-<%= @index %>').html("<%= escape_javascript render(:partial => 'qty_n_price_row', :locals => { index: @index, item: @item } ) %>");
	$('[id^="litp-id-"]').each(function() {
	   sum += parseFloat($(this).text().slice(3));
	});
	sum_total = sum.toFixed(2);
	$('#line-items-total-sum').text("Total: €" + sum_total).effect( "highlight", {color: 'lightblue'}, 250 );
	$('#litp-id-<%= @index %>').effect( "highlight", {color: 'lightblue'}, 250 );
});

app/views/line_items/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Product:</strong>
  <%= @line_item.product_id %>
</p>

<p>
  <strong>Cart:</strong>
  <%= @line_item.cart_id %>
</p>

<%= link_to 'Edit', edit_line_item_path(@line_item) %> |
<%= link_to 'Back', line_items_path %>